#include <stdio.h> 
#include <string.h>
#include <dlfcn.h>
#include <sys/mman.h>
#include <sys/types.h>
#define DEBUG 1

#ifdef DEBUG
FILE *msg;
#endif
 
static void patch_fontsize()
{
	void *myself;
	unsigned *original1;
	unsigned *original2;
	unsigned page1;
	unsigned page2;
	unsigned page3;
	int i;
	unsigned int calculated_offset1;
#define PATCH1_OFFSET_B650	0x7C
#define PATCH1_OFFSET_MAX	0xFF
	static const unsigned pattern1[1] = {0xe2811018}; //ADD     R1, R1, #0x18
	static const unsigned  patchcode1[1] = {0xe2811020}; //ADD     R1, R1, #0x20
	unsigned int calculated_offset2;
#define PATCH2_OFFSET_B650	0x0C
#define PATCH2_OFFSET_MAX	0x1C
	static const unsigned pattern2[1] = {0xe2811018}; //ADD     R1, R1, #0x18
	static const unsigned patchcode2[1] = {0xe2811020}; //ADD     R1, R1, #0x20
	unsigned int calculated_offset3;
#define PATCH3_OFFSET_B650	0xC8
#define PATCH3_OFFSET_MAX	0xFF
	static const unsigned pattern3[1] = {0xfff0f0f0}; // local data in .text segment AARRGGBB
	static const unsigned  patchcode3[1] = {0xffffff00}; // local data in .text segment AARRGGBB
	/* Get addresses of functions to patch */
	if ( (myself = dlopen(NULL,RTLD_NOW | RTLD_GLOBAL)) == NULL )
	{
#ifdef DEBUG
		fputs("fontsize: cannot dlopen myself\n",msg);
#endif 
 		return;
	}
	original1 = dlsym(myself,"_ZN20CMultimediaMovieInfo11InitCaptionEv");
	original2 = dlsym(myself,"_ZN20CMultimediaMovieInfo21UpdateCaptionTextSizeEi");
	dlclose(myself);
	if ( (original1 == NULL) ||
		 (original2 == NULL) )
	{
#ifdef DEBUG
		fputs("fontsize: cannot locate functions\n",msg);
#endif 
		return;
	}
	/* Find original code */
	for(i=0;i<PATCH1_OFFSET_MAX/4;i++)
	{
	   if(*(original1+i)==pattern1[0]){
         calculated_offset1=i;
#ifdef DEBUG
		   fprintf(msg,"fontsize: Found offset for 1st function: %d instructions after function start\n",calculated_offset1);
#endif          
         break;
      }
   }
	for(i=0;i<PATCH2_OFFSET_MAX/4;i++)
	{
	   if(*(original2+i)==pattern2[0]){
         calculated_offset2=i;
#ifdef DEBUG
		   fprintf(msg,"fontsize: Found offset for 2nd function: %d instructions after function start\n",calculated_offset2);
#endif          
         break;
      }
   }
	for(i=0;i<PATCH3_OFFSET_MAX/4;i++)
	{
	   if(*(original1+i)==pattern3[0]){
         calculated_offset3=i;
#ifdef DEBUG
		   fprintf(msg,"fontsize: Found offset for 3rd function: %d instructions after function start\n",calculated_offset3);
#endif          
         break;
      }
   }
   
	/* Patch */
	page1 = ((unsigned) original1+calculated_offset1) & ~0x0FFF;
	page2 = ((unsigned) original2+calculated_offset2) & ~0x0FFF;
	page3 = ((unsigned) original1+calculated_offset3) & ~0x0FFF;

	mprotect((void *) page1, 8192, PROT_READ | PROT_WRITE | PROT_EXEC);
	original1[calculated_offset1] = patchcode1[0];
	if (page1 != page2)
	{
		mprotect((void *) page1, 8192, PROT_READ | PROT_EXEC);
		mprotect((void *) page2, 8192, PROT_READ | PROT_WRITE | PROT_EXEC);
	}
	original2[calculated_offset2] = patchcode2[0];
	if (page2 != page3)
	{
		mprotect((void *) page2, 8192, PROT_READ | PROT_EXEC);
		mprotect((void *) page3, 8192, PROT_READ | PROT_WRITE | PROT_EXEC);
	}
	original1[calculated_offset3] = patchcode3[0];
	mprotect((void *) page3, 8192, PROT_READ | PROT_EXEC);
#ifdef DEBUG
	fputs("fontsize: Patch applied!",msg);
#endif
}

int Game_Main(const char  *path, const char *udn __attribute__ ((unused)))
{
#ifdef DEBUG
	msg = fopen("/dev/kmsg","a+");
#endif
	patch_fontsize();
#ifdef DEBUG
	fclose(msg);
#endif
	return 1;
}

